
//+------------------------------------------------------------------+
//| This EA should be good for eurusd with default setting.          |
//|                For M5 timeframe only                             |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "newdigital"
#property link      "http://www.forex-tsd.com"

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4


extern bool    ECNbroker       = true;
extern int     MagicFactor     = 10;
extern bool    NoHedge         = true;          //the main "hedge /no hedge" switch. If set to false, it will not check any hedged positions
extern bool    StrictNoHedge   = true;          //the way how hedging is checked; If set to true, it will check the entire account for the 
                                                //symbol the EA is attached to and if any "counter" order is opened it will prevent a new 
                                                //order to be opened in the opposite way. If set to false, it will check the symbol the EA 
                                                //is attached to only within given magic number (so, it will prevent hedging only within EA 
                                                //not within account) If broker does not allow hedging, you must set this parameter to true, 
                                                //but it is useful in cases when someone wants to test it and the effect of the no hedging 
                                                //rule to it's work (author mladen)
extern bool   EachTickMode     = false;
extern double Lots             = 0.1;
extern int    Slippage         = 3;
extern bool   StopLossMode     = True;
extern int    StopLoss         = 100;
extern bool   TakeProfitMode   = True;
extern int    TakeProfit       = 100;
extern bool   TrailingStopMode = True;
extern int    TrailingStop     = 30;
extern double MaximumRisk      = 0;
extern double DecreaseFactor   = 3;
extern int    MaxOrders        = 3;

extern string indis            = "Indicator settings";
extern string TS_Inputs        = "Jurik TrendStrength parameters";
extern int    TS_TimeFrame     = 0;         // Time Frame in min
extern int    RsxLength        = 14;
extern int    Price            = 0;
extern int    SmoothLength     = 5;
extern int    SmoothPhase      = 0;
extern double K                = 4.236;     // Multiplier 

extern string AS_Inputs        = "AbsoluteStrength parameters";
extern int    AS_TimeFrame     = 240;      // Time Frame in min
extern int    AS_MathMode      = 0;        // 0-RSI method; 1-Stoch method; 2-ADX method
extern int    AS_Length        = 10;       // Period of evaluation
extern int    AS_Smooth        = 5;        // Period of smoothing
extern int    AS_Signal        = 5;        // Period of Signal Line
extern int    AS_Price         = 0;        // Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int    AS_ModeMA        = 3;        // Mode of Moving Average

extern double iSAR_Step        = 0.02;
extern double iSAR_Maximum     = 0.2;
extern int    iSAR_Shift       = 0;




extern bool   UseHourTrade     = false;
extern int    FromHourTrade    = 0;
extern int    ToHourTrade      = 24;

extern bool   SpreadProtection = True;     // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int    PipTolerance     = 12;       // value in pips over normal spread to activate the SpreadProtection






int    MagicNumber;
int    PipMultiplier=1;
int    BarCount;
int    Current;
int    DontContinue=0;
double Spread=0,WorstSpread=0,NormalSpread=0;
double TStrend, pTStrend;
double Bulls, sBulls, Bears, sBears;
bool   TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {


   int MNEACode, MNSymbol, MNPeriod, a;
   MNPeriod=Period();
   for (a = 0; a < 7; a++) MNSymbol += StringGetChar(Symbol(), a);
   for (a = 0; a < StringLen(WindowExpertName())+1; a++) MNEACode += StringGetChar(WindowExpertName(), a);
   MagicNumber =MagicFactor * MNSymbol+10*MNPeriod+10*MNEACode;  
   NormalSpread=MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,Digits%2);

   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   if (UseHourTrade){
      if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
         Comment("Time for trade has not come else!");
         return(0);
      }  
   }
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   double BuyStop, SellStop;
   
   int digit  = MarketInfo(Symbol(),MODE_DIGITS);
   if(digit==3 || digit==5) PipMultiplier=10;

   if (EachTickMode && Bars != BarCount) EachTickMode = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
   
   
   Spread=MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,Digits%2);
  
   if (Spread>WorstSpread) {WorstSpread=Spread;}
   if (SpreadProtection && Spread>NormalSpread+PipTolerance){DontContinue=1;} else {DontContinue=0;}
   
   //+------------------------------------------------------------------+
   //| Signal Begin                                                     |
   //+------------------------------------------------------------------+

      TStrend  = iCustom(Symbol(),TS_TimeFrame,"Jurik TrendStrength",RsxLength,Price,SmoothLength,SmoothPhase,K,6,Current);
      pTStrend = iCustom(Symbol(),TS_TimeFrame,"Jurik TrendStrength",RsxLength,Price,SmoothLength,SmoothPhase,K,6,Current+1);
      Bulls    = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,0,0,0,Current);
      sBulls   = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,0,0,2,Current);
      Bears    = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,0,0,1,Current);
      sBears   = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength_v1.1",AS_MathMode,AS_Length,AS_Smooth,AS_Signal,AS_Price,AS_ModeMA,0,0,3,Current);

      if (TStrend > 0 && Bulls > sBulls && Bulls > Bears) Order = SIGNAL_BUY;
      if (TStrend < 0 && Bears > sBears && Bulls < Bears) Order = SIGNAL_SELL;

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))) && checkhedge(OP_BUY) && DontContinue==0) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLoss >0 ) StopLossLevel = Ask - StopLoss * Point * PipMultiplier ; else StopLossLevel = 0;
         if (TakeProfit > 0) TakeProfitLevel = Ask + TakeProfit * Point * PipMultiplier ; else TakeProfitLevel = 0;
         
         if (!ECNbroker){
            Ticket = OrderSend(Symbol(), OP_BUY, LotsOptimized(), 
                     NormalizeDouble(Ask,digit), 
                     Slippage*PipMultiplier, 
                     NormalizeDouble(StopLossLevel,digit),  
                     NormalizeDouble(TakeProfitLevel,digit),  
                     "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
            if(Ticket > 0) {
               if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("BUY order opened : ", OrderOpenPrice()); 
               else Print("Error opening BUY order : ", GetLastError());
            }
            else Print("Error opening BUY order : ", GetLastError());
         }
         else {
            Ticket = OrderSend(Symbol(), OP_BUY, LotsOptimized(), 
                     NormalizeDouble(Ask,digit), 
                     Slippage*PipMultiplier, 
                     0,  
                     0,  
                     "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
            if(Ticket > 0) {
              if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
                  OrderModify(Ticket,OrderOpenPrice(),NormalizeDouble(StopLossLevel,digit),NormalizeDouble(TakeProfitLevel,digit),0,CLR_NONE);
                  Print("BUY order opened : "       , OrderOpenPrice());
              } 
              else Print("Error opening BUY order : ", GetLastError());                    
            }
            else Print("Error opening BUY order : ", GetLastError());
         }   
         
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))) && checkhedge(OP_SELL) && DontContinue==0) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         if (StopLoss >0 ) StopLossLevel = Bid + StopLoss * Point * PipMultiplier; else StopLossLevel = 0;
         if (TakeProfit > 0) TakeProfitLevel = Bid - TakeProfit * Point * PipMultiplier; else TakeProfitLevel = 0;
         
         if (!ECNbroker){
            Ticket = OrderSend(Symbol(), OP_SELL, LotsOptimized(), 
                     NormalizeDouble(Bid,digit), 
                     Slippage*PipMultiplier, 
                     NormalizeDouble(StopLossLevel,digit),  
                     NormalizeDouble(TakeProfitLevel,digit),  
                     "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         
            if(Ticket > 0) {
              if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("SELL order opened : ", OrderOpenPrice());
              else Print("Error opening SELL order : ", GetLastError());
            }
            else Print("Error opening SELL order : ", GetLastError());
         }
         else {
            Ticket = OrderSend(Symbol(), OP_SELL, LotsOptimized(), 
                     NormalizeDouble(Bid,digit), 
                     Slippage*PipMultiplier, 
                     0,  
                     0,  
                     "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
            if(Ticket > 0){
              if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
                  OrderModify(Ticket,OrderOpenPrice(),NormalizeDouble(StopLossLevel,digit),NormalizeDouble(TakeProfitLevel,digit),0,CLR_NONE);
                  Print("SELL order opened : "       , OrderOpenPrice());
              }        
              else Print("Error opening SELL order : ", GetLastError());             
            }
            else Print("Error opening SELL order : ", GetLastError());
         }  
           
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }   
   }

   //Check position
   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         if(OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber ) {
            //Close
            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage*PipMultiplier, MediumSeaGreen);
               if (EachTickMode) TickCheck = True;
               if (!EachTickMode) BarCount = Bars;
               return(0);
            }
            //Trailing stop
            if(TrailingStopMode) 
            { 
            if (TrailingStop > 0) 
            BuyStop = Bid - Point * PipMultiplier * TrailingStop;
            else BuyStop = iSAR(NULL, 0,iSAR_Step, iSAR_Maximum , Current + 0);                   
                         
               if(BuyStop > OrderOpenPrice() || TrailingStop==0) 
               {
                  if(OrderStopLoss() < BuyStop) 
                  {
                  //Print(" BS=",BuyStop);  
                  OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0, MediumSeaGreen);
                  if (!EachTickMode) BarCount = Bars;
                  return(0);
                  }
               }
            }
         } 
         else {
            if(OrderType()==OP_SELL && OrderMagicNumber()==MagicNumber) {
           
//Close
                if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
                   OrderClose(OrderTicket(), OrderLots(), Ask, Slippage*PipMultiplier, DarkOrange);
                   if (EachTickMode) TickCheck = True;
                   if (!EachTickMode) BarCount = Bars;
                   return(0);
                }
//Trailing stop
                if (TrailingStopMode) {
                    if(TrailingStop > 0) SellStop = Ask + Point * PipMultiplier * TrailingStop;
                    else SellStop = iSAR(NULL, 0,iSAR_Step, iSAR_Maximum , Current + 0);                  
                  //Print(" BS=",SellStop);    
                    if( OrderOpenPrice() > SellStop || TrailingStop==0 ) {
                       if((OrderStopLoss() > SellStop) || (OrderStopLoss() == 0)) {
                         //Print(" SS=",SellStop);
                           OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0, DarkOrange);
                           if (!EachTickMode) BarCount = Bars;
                           return(0);
                       }
                    }
                }
            }
         }
      }
   }

   if (!EachTickMode) BarCount = Bars;
   Comment (ShowInfo());
   return(0);
}
//--------------------------------------
//FUNCTION ShowInfo
//--------------------------------------
string ShowInfo() {
   string ls_0 = "";
   ls_0 = StringConcatenate ("MagicNumber: ", MagicNumber, "\n");   

   double CurrentSpread = MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,Digits%2);

   ls_0 = StringConcatenate (ls_0, "CurrentSpread ", DoubleToStr(CurrentSpread, 1));
   return (ls_0);
}
//--------------------------------------
//FUNCTION ScanTrades
//--------------------------------------
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == MagicNumber) 
   numords++;
   }
   return(numords);
}  


double LotsOptimized()
{
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract=MarketInfo(Symbol(),MODE_LOTSIZE);
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
//--- basic formula
   if (MaximumRisk > 0)
   {
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk*AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
      //----
      if(OrderProfit()>0) break;
      if(OrderProfit()<0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,2);
   }
//--- check min, max and step
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
//---
   return(lot);
}   

//+------------------------------------------------------------------+
//--------------------------------------
//FUNCTION checkhedge - for hedge/nohedge selection
//--------------------------------------
bool checkhedge(int openWhat){
   if (!NoHedge) return(true);
   for(int i=0; i < OrdersTotal(); i++){
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if (OrderSymbol() != Symbol()) continue;
      if (!StrictNoHedge && OrderMagicNumber() != MagicNumber) continue;
      
      if (OrderType() == OP_BUY  && openWhat == OP_SELL) return(false); 
      if (OrderType() == OP_SELL && openWhat == OP_BUY)  return(false); 
   }      
   return(true);
}
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
 